#!/bin/sh
#
# script:  serv2xml.sh
# author:  vlamo <http://dream.altmaster.net>
# adapted for ASUS OPlay moServece SATTV: andr128

# ====================================================
# !!! you should not need to change anything below !!!
# !!! only if you know what doing                  !!!
# ====================================================
echo "Please wait.."

IP=$(ifconfig eth0 | grep inet | awk ' { FS=":" ; print $2 } ' | awk ' { print $1 } ')
#IP="192.168.1.115"	# IP dreambox set
PORT="31344"		# Port streaming for PLI
XML="/tmp/sat_tv.xml"	# Output file

# mask to print service types:
#    t - tv services
#    r - radio services
#    d - data services
#
#TYPEMASK="t,r,d"
TYPEMASK="t"


LINK="http://$IP:$PORT/"
E1_SERVDB="/var/tuxbox/config/enigma/services"	# <-- path to service db for enigma1
E2_SERVDB="/etc/enigma2/lamedb"			# <-- path to service db for enigma2
E1_ZAPCMD="http://$IP/cgi-bin/zapTo?path="
E2_ZAPCMD="http://$IP/web/zap?sRef="

if [ -f $E1_SERVDB ]; then
	SERVDB=$E1_SERVDB
	ZAPCMD=$E1_ZAPCMD
elif [ -f $E2_SERVDB ]; then
	SERVDB=$E2_SERVDB
	ZAPCMD=$E2_ZAPCMD
fi

if [ -n "$SERVDB" ]; then
	exec > $XML # Redirect to file

	awk -v flg=$TYPEMASK '
		BEGIN {
			idx = 0
			SR = NM = PV = TP = OP = ""
			if (flg == "") flg = "t,r,d"
		}

		/^services/ {

			print "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>"
			print ""
			print "<!-- This file is generated on Dreambox for service player ASUS O!Play -->"
			print ""			
			print "<playlist>"
			print ""
			print "\t<options>"
				print "\t\t<status>"
				print "\t\t<request>http://'$IP'/xml/boxstatus</request>"
				print "\t\t</status>"
			print "\t<wakeup>"
				print "\t\t<title>Включить DreamBox</title>"
				print "\t\t<request>http://'$IP'/cgi-bin/admin?command=wakeup</request>"
			print "\t</wakeup>"
			print "\t<standby>"
				print "\t\t<title>Выключить DreamBox</title>"
				print "\t\t<request>http://'$IP'/cgi-bin/admin?command=standby</request>"
			print "\t</standby>"
			print "\t</options>"
			print ""

			idx = 1
			while (getline > 0) {
				if ( index($0, "end") == 1 ) { idx = 0; break }

				if ( idx == 1 ) {
					cnt = split($0, A, /:/)
					if ( cnt > 5 ) {
						for (i=1; i<cnt; i++) A[i] = gensub("^0*", "", "g", A[i])
						SR = sprintf("1:0:%x:%s:%s:%s:%s:0:0:0:", A[5], A[1], A[3], A[4], A[2])
						if ((A[5] == 1) || (A[5] == 17) || (A[5] == 22) || (A[5] == 25) || (A[5] == 134) || (A[5] == 195)) {
							TP = "TV"
						}else if ((A[5] == 2) || (A[5] == 10)) {
							TP = "RADIO"
						}else{
							TP = "DATA"
						}
						p = sprintf("%d", "0x" gensub(".\{4\}$", "", "g", A[2])) + 0
						if ( p > 1800 ) { p = 3600 - p; h = "W" } else { h = "E" }
						OP = sprintf("%d.%d°%s", p/10, p%10, h)
					}
				}else if ( idx == 2 ) {
					NM = gensub("[[:space:]]*$", "", "g", $0)
				}else if ( idx == 3 ) {
					PV = gensub(",.*$", "", "g", gensub("^.*p:", "", "g", $0))
				}

				idx += 1
				if ( idx > 3 ) {
					if (((TP == "TV") && (index(flg,"t"))) || ((TP == "RADIO") && (index(flg,"r"))) || ((TP == "DATA") && (index(flg,"d")))) {
						print "\t<item>"
						print "\t\t<title>" NM "</title>"
						print "\t\t<satpos>" OP "</satpos>"
						print "\t\t<provider>" PV "</provider>"
						print "\t\t<type>" TP "</type>"
						print "\t\t<link>'$LINK'</link>"
						print "\t\t<request>'$ZAPCMD'" SR "</request>"
						print "\t</item>"
					}
					idx = 1
					SR = NM = PV = TP = OP = ""
				}
			}
			print "</playlist>"
		}
	' $SERVDB

else
	echo "Error: file '$E1_SERVDB' not exist." >&2
	echo "Error: file '$E2_SERVDB' not exist." >&2
	exit 1
fi

exit 0

